package org.netkernel.client.http.assertion;

import org.netkernel.module.standard.endpoint.StandardAccessorImpl;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.layer0.nkf.INKFResponseReadOnly;

import java.util.regex.Pattern;

public class AssertReturnCode extends StandardAccessorImpl
  {

  public void onSource(INKFRequestContext context) throws Exception
    {
    INKFResponseReadOnly response = context.source("arg:result",INKFResponseReadOnly.class);
    String matchExpression = context.source("arg:condition", String.class);
    Integer httpReturnCode = (Integer)response.getHeader("HTTP_ACCESSOR_STATUS_CODE_METADATA");

    boolean result = Pattern.matches(matchExpression, httpReturnCode.toString());
    context.createResponseFrom(result).setNoCache();
    }
  }


