package org.netkernel.client.http.endpoint;

import javax.net.ssl.SSLContext;

import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.conn.params.ConnManagerParams;
import org.apache.http.conn.params.ConnPerRouteBean;
import org.apache.http.conn.scheme.PlainSocketFactory;
import org.apache.http.conn.scheme.Scheme;
import org.apache.http.conn.scheme.SchemeRegistry;
import org.apache.http.conn.ssl.SSLSocketFactory;
import org.apache.http.impl.conn.tsccm.ThreadSafeClientConnManager;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpParams;
import org.netkernel.layer0.nkf.INKFRequestContext;
import org.netkernel.module.standard.endpoint.StandardAccessorImpl;

public class DefaultConnectionManagerAccessor extends StandardAccessorImpl
{
	public static final int MAXIMUM_TOTAL_HTTP_CLIENT_CONNECTIONS=64;
	public static final int MAXIMUM_TOTAL_HTTP_CLIENT_CONNECTIONS_PER_HOST=8;
	
	public DefaultConnectionManagerAccessor()
	{	this.declareThreadSafe();		
	}

	@Override
	public void onSource(INKFRequestContext aContext) throws Exception
	{	SchemeRegistry sreg=new SchemeRegistry();
		sreg.register(new Scheme("http", 80, PlainSocketFactory.getSocketFactory()));
		SSLSocketFactory sf=SSLSocketFactory.getSocketFactory();
		Scheme https=new Scheme("https", 443, sf);
		sreg.register(https);
		ThreadSafeClientConnManager m = new ThreadSafeClientConnManager(sreg);
		m.setMaxTotal(MAXIMUM_TOTAL_HTTP_CLIENT_CONNECTIONS);
		m.setDefaultMaxPerRoute(MAXIMUM_TOTAL_HTTP_CLIENT_CONNECTIONS_PER_HOST);
		aContext.createResponseFrom(m);
	}
}
