package org.netkernel.client.http.representation;

public class HttpClientConfig implements IHttpClientConfig
{
	private boolean mFollowRedirects;
	private long mMaximumAcceptableContentLength;
	private int mMaximumConnectionsPerHost;
	private int mTotalConnections;
	private int mStateExpirationTime;
	private int mRetryAttempts;
	private int mConnectTimeout;
	private int mTimeout;
	private String mProxyHost;
	private int mProxyPort;
	private String mProxyUser;
	private String mProxyPassword;
	private String mProxyNTLMHost;
	private String mProxyNTLMDomain;
	private boolean mExpectContinue;
	private String mUserAgent;

/** Creates a new instance of HttpClientConfigAspect */
	public HttpClientConfig(
		boolean	aFollowRedirects,
		long aAcceptableContentLength,
		int aConnectionsPerHost,
		int aTotalConnections,
		int aStateExpirationTime,
		int aRetryAttempts,
		int aConnectTimeout,
		int aTimeout,
		String aProxyHost,
		int aProxyPort,
		String aProxyUser,
		String aProxyPassword,
		String aProxyNTLMHost,
		String aProxyNTLMDomain,
		boolean aExpectContinue,
		String aUserAgent
	)
	{	mFollowRedirects=aFollowRedirects;
		mMaximumAcceptableContentLength =aAcceptableContentLength;
		mMaximumConnectionsPerHost =aConnectionsPerHost;
		mTotalConnections=aTotalConnections;
		mStateExpirationTime=aStateExpirationTime;
		mRetryAttempts=aRetryAttempts;
		mConnectTimeout=aConnectTimeout;
		mTimeout=aTimeout;
		mProxyHost=aProxyHost;
		mProxyPort=aProxyPort;
		mProxyUser=aProxyUser;
		mProxyPassword=aProxyPassword;
		mProxyNTLMHost=aProxyNTLMHost;
		mProxyNTLMDomain=aProxyNTLMDomain;
		mExpectContinue=aExpectContinue;
		mUserAgent=aUserAgent;
	}
	
	public boolean followRedirects()
	{	return mFollowRedirects;
	}
	
	public long getMaximumAccepatbleContentLength()
	{	return mMaximumAcceptableContentLength;
	}
	
	public int getMaximumConnectionsPerHost()
	{	return mMaximumConnectionsPerHost;
	}
	
	public int getMaximumTotalConnections()
	{	return mTotalConnections;
	}
	
	public int getStateExpirationTime()
	{	return mStateExpirationTime;
	}
	
	public int getNumberOfRetryAttempts()
	{	return mRetryAttempts;
	}
	
	public int getConnectTimeout()
	{	return mConnectTimeout;		
	}
	
	public int getTimeout()
	{	return mTimeout;		
	}
	
	public String getProxyHost()
	{	return mProxyHost;		
	}
	public int getProxyPort()
	{	return mProxyPort;		
	}
	public String getProxyUser()
	{	return mProxyUser;		
	}
	public String getProxyPassword()
	{	return mProxyPassword;		
	}
	public String getProxyNTLMHost()
	{	return mProxyNTLMHost;		
	}
	public String getProxyNTLMDomain()
	{	return mProxyNTLMDomain;		
	}
	public boolean expectContinue()
	{	return mExpectContinue;		
	}
	public String getUserAgent()
	{	return mUserAgent;		
	}
}
